Main Page Modules Class Hierarchy Alphabetical List Compound List File List Compound Members

# SoIndexedFaceSet Class Reference
[Nodes]

The SoIndexedFaceSet class is used to handle generic indexed facesets. More...

`#include <Inventor/nodes/SoIndexedFaceSet.h>`

Inheritance diagram for SoIndexedFaceSet:

List of all members.

## Public Methods
| SoIndexedFaceSet (void)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual SbBool | generateDefaultNormals (SoState *state, SoNormalBundle *bundle)
virtual SbBool | generateDefaultNormals (SoState *state, SoNormalCache *cache)
## Static Public Methods
void | initClass (void)
## Protected Methods
virtual | ~SoIndexedFaceSet ()
virtual void | generatePrimitives (SoAction *action)

## Detailed Description

The SoIndexedFaceSet class is used to handle generic indexed facesets.

Faces are specified using the coordIndex field. Each face must be terminated by a negative (-1) index. Coordinates, normals, materials and texture coordinates from the current state (or from the vertexProperty node if set), can be indexed to create triangles, quads or polygons.

Binding PER_VERTEX_INDEXED, PER_VERTEX, PER_FACE_INDEXED, PER_FACE or OVERALL can be set for material, and normals. The default material binding is OVERALL. The default normal binding is PER_VERTEX_INDEXED. When PER_VERTEX_INDEXED binding is used and the corresponding materialIndex, normalIndex, texCoordIndex field is empty, the coordIndex field will be used to index material, normal or texture coordinate. If you do specify indices for material, normals or texture coordinates for PER_VERTEX_INDEXED binding, make sure your index array matches the coordIndex array (there should be -1 wherever there is a -1 in the coordIndex field. This is done to make this node more human readable.)

## Constructor & Destructor Documentation

SoIndexedFaceSet::SoIndexedFaceSet | ( | void |  | ) |

| Constructor.

SoIndexedFaceSet::~SoIndexedFaceSet | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoIndexedFaceSet::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoIndexedShape.

void SoIndexedFaceSet::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoShape.

void SoIndexedFaceSet::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoShape.

SbBool SoIndexedFaceSet::generateDefaultNormals | ( | SoState * | state,
|  | SoNormalBundle * | bundle
| ) | `[virtual]`

| Subclasses should override this method to generate default normals using the SoNormalBundle class. `TRUE` should be returned if normals were generated, `FALSE` otherwise. Default method returns `FALSE`. Reimplemented from SoVertexShape.

SbBool SoIndexedFaceSet::generateDefaultNormals | ( | SoState * | state,
|  | SoNormalCache * | nc
| ) | `[virtual]`

| Subclasses should override this method to generate default normals using the SoNormalCache class. This is more effective than using SoNormalGenerator. Return `TRUE` if normals were generated, `FALSE` otherwise. Default method just returns `FALSE`. This method is not part of the original SGI Open Inventor API. Reimplemented from SoVertexShape.

void SoIndexedFaceSet::generatePrimitives | ( | SoAction * | action | ) | `[protected, virtual]`

| The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().) The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller. Implements SoShape.

The documentation for this class was generated from the following files:

- SoIndexedFaceSet.h
- SoIndexedFaceSet.cpp